<template>
  <div class="card" type="button">
    <div class="card-body">
      <h5 class="card-title">{{ card.name }}</h5>
      <p class="card-text text-gray-600">{{ card.descrption }}</p>
    </div>
    <div class="card-body d-flex">
      <div class="w-50 d-flex align-items-center">
        <app-icon class="text-gray-600 mr-2" size="lg" icon="clock"></app-icon>
        <span class="text-primary">{{ date }}</span>
      </div>
      <div class="w-50 d-flex justify-content-end">
        <app-icon v-if="todos.length > 0" icon="list-ul"></app-icon>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { Card, LocalDatabase, Todo } from "@/core/database";
import { TodoRepository } from "@/core/repositories";
import dayjs from "dayjs";
import { defineComponent, PropType } from "vue";
import { SubSink } from "subsink";
export default defineComponent({
  created() {
    LocalDatabase.getInstance().then(async (db) => {
      this.todoRepository = TodoRepository.getInstance(db);
      const todoObservable = await this.todoRepository.watchAllItems(
        "cardId",
        this.card.id
      );
      this.subSink.sink = todoObservable.subscribe((todos) => {
        if (todos) {
          this.todos = todos;
        }
      });
    });
  },
  props: {
    card: {
      type: Object as PropType<Card>,
      required: true,
    },
  },
  data() {
    return {
      todoRepository: {} as TodoRepository,
      todos: [] as Todo[],
      subSink: new SubSink(),
    };
  },
  computed: {
    date(): string {
      return dayjs(this.card.date).format("DD MMM");
    },
  },
  unmounted() {
    this.subSink.unsubscribe();
  },
});
</script>

<style scoped>
.card {
  width: 325px;
  height: 237px;
  flex: 0 0 325px;
}
</style>
